"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const universal_cookie_1 = __importDefault(require("universal-cookie"));
const react_1 = __importStar(require("react"));
const react_locale_1 = require("@monstrs/react-locale");
const react_intl_1 = require("react-intl");
const DEFAULT_LOCALE = 'ru';
exports.withIntl = ({ default: defaultLocale = DEFAULT_LOCALE, supported: supportedLocales = [], load = (locale) => ({}), }) => WrapperComponent => class WithIntl extends react_1.Component {
    constructor(props) {
        super(props);
        this.onChange = (locale) => __awaiter(this, void 0, void 0, function* () {
            const messages = load ? yield load(locale) : {};
            const cookies = new universal_cookie_1.default();
            cookies.set('locale', locale);
            this.setState({ locale, messages });
        });
        this.state = {
            locale: props.locale,
            messages: props.messages,
        };
        this.store = new react_locale_1.LocaleStore(props.locale, supportedLocales);
    }
    static getInitialProps(context) {
        return __awaiter(this, void 0, void 0, function* () {
            let props = {};
            const { ctx: { req, res }, } = context;
            if (WrapperComponent.getInitialProps) {
                props = yield WrapperComponent.getInitialProps(context);
            }
            if (!process.browser) {
                let locale = defaultLocale;
                if (!req.acceptsLanguages) {
                    return Object.assign(Object.assign({}, props), { locale: defaultLocale, messages: {} });
                }
                const acceptLang = req.acceptsLanguages(defaultLocale, ...supportedLocales);
                if (supportedLocales.includes(acceptLang)) {
                    locale = acceptLang;
                }
                const cookies = new universal_cookie_1.default(req.get('cookie'));
                if (cookies.get('locale')) {
                    if (supportedLocales.includes(cookies.get('locale'))) {
                        locale = cookies.get('locale');
                    }
                }
                else if (!res.headersSent) {
                    res.cookie('locale', locale);
                }
                const messages = load ? yield load(locale) : {};
                return Object.assign(Object.assign({}, props), { locale,
                    messages });
            }
            return Object.assign(Object.assign({}, props), { locale: window.__NEXT_DATA__.props.locale, messages: window.__NEXT_DATA__.props.messages });
        });
    }
    componentDidMount() {
        this.store.addChangeListener(this.onChange);
    }
    componentWillUnmount() {
        this.store.removeChangeListener(this.onChange);
    }
    render() {
        const { locale, messages } = this.state;
        return (react_1.default.createElement(react_locale_1.LocaleProvider, { value: this.store },
            react_1.default.createElement(react_intl_1.IntlProvider, { locale: locale, messages: messages, defaultLocale: defaultLocale },
                react_1.default.createElement(WrapperComponent, Object.assign({}, this.props, { locale: locale })))));
    }
};
